package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.Minecraft;

import net.mcreator.puzzle_code.world.inventory.FillerItemCodeBlockGUI2Menu;
import net.mcreator.puzzle_code.procedures.ReturnzPos2Procedure;
import net.mcreator.puzzle_code.procedures.ReturnyPos2Procedure;
import net.mcreator.puzzle_code.procedures.ReturnxPos2Procedure;
import net.mcreator.puzzle_code.network.FillerItemCodeBlockGUI2ButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class FillerItemCodeBlockGUI2Screen extends AbstractContainerScreen<FillerItemCodeBlockGUI2Menu> {
	private final static HashMap<String, Object> guistate = FillerItemCodeBlockGUI2Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox xPos2Field;
	EditBox yPos2Field;
	EditBox zPos2Field;
	Button button_1;
	Button button_3;
	Button button_2;
	ImageButton imagebutton_enter_button;
	ImageButton imagebutton_enter_button1;
	ImageButton imagebutton_enter_button2;
	ImageButton imagebutton_edit_button;
	ImageButton imagebutton_edit_button1;
	ImageButton imagebutton_edit_button2;

	public FillerItemCodeBlockGUI2Screen(FillerItemCodeBlockGUI2Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 174;
		this.imageHeight = 146;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/filler_item_code_block_gui_2.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		xPos2Field.render(guiGraphics, mouseX, mouseY, partialTicks);
		yPos2Field.render(guiGraphics, mouseX, mouseY, partialTicks);
		zPos2Field.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (xPos2Field.isFocused())
			return xPos2Field.keyPressed(key, b, c);
		if (yPos2Field.isFocused())
			return yPos2Field.keyPressed(key, b, c);
		if (zPos2Field.isFocused())
			return zPos2Field.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void resize(Minecraft minecraft, int width, int height) {
		String xPos2FieldValue = xPos2Field.getValue();
		String yPos2FieldValue = yPos2Field.getValue();
		String zPos2FieldValue = zPos2Field.getValue();
		super.resize(minecraft, width, height);
		xPos2Field.setValue(xPos2FieldValue);
		yPos2Field.setValue(yPos2FieldValue);
		zPos2Field.setValue(zPos2FieldValue);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.label_x2_bnbtintegerxpos2"), 5, 29, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.label_y2_bnbtintegerypos2"), 5, 65, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.label_z2_bnbtintegerzpos2"), 5, 101, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnxPos2Procedure.execute(world, x, y, z), 28, 29, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnyPos2Procedure.execute(world, x, y, z), 28, 65, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnzPos2Procedure.execute(world, x, y, z), 28, 101, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		xPos2Field = new EditBox(this.font, this.leftPos + 6, this.topPos + 7, 111, 18, Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.xPos2Field")) {
			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.xPos2Field").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos, boolean flag) {
				super.moveCursorTo(pos, flag);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.xPos2Field").getString());
				else
					setSuggestion(null);
			}
		};
		xPos2Field.setMaxLength(32767);
		xPos2Field.setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.xPos2Field").getString());
		guistate.put("text:xPos2Field", xPos2Field);
		this.addWidget(this.xPos2Field);
		yPos2Field = new EditBox(this.font, this.leftPos + 6, this.topPos + 43, 111, 18, Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.yPos2Field")) {
			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.yPos2Field").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos, boolean flag) {
				super.moveCursorTo(pos, flag);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.yPos2Field").getString());
				else
					setSuggestion(null);
			}
		};
		yPos2Field.setMaxLength(32767);
		yPos2Field.setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.yPos2Field").getString());
		guistate.put("text:yPos2Field", yPos2Field);
		this.addWidget(this.yPos2Field);
		zPos2Field = new EditBox(this.font, this.leftPos + 6, this.topPos + 79, 111, 18, Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.zPos2Field")) {
			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.zPos2Field").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos, boolean flag) {
				super.moveCursorTo(pos, flag);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.zPos2Field").getString());
				else
					setSuggestion(null);
			}
		};
		zPos2Field.setMaxLength(32767);
		zPos2Field.setSuggestion(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.zPos2Field").getString());
		guistate.put("text:zPos2Field", zPos2Field);
		this.addWidget(this.zPos2Field);
		button_1 = Button.builder(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.button_1"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(0, x, y, z));
				FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 50, this.topPos + 119, 18, 20).build();
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_3 = Button.builder(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.button_3"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(1, x, y, z));
				FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 95, this.topPos + 119, 18, 20).build();
		guistate.put("button:button_3", button_3);
		this.addRenderableWidget(button_3);
		button_2 = Button.builder(Component.translatable("gui.puzzle_code.filler_item_code_block_gui_2.button_2"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(2, x, y, z));
				FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 73, this.topPos + 119, 18, 20).build();
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		imagebutton_enter_button = new ImageButton(this.leftPos + 145, this.topPos + 6, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(3, x, y, z));
						FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 3, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button", imagebutton_enter_button);
		this.addRenderableWidget(imagebutton_enter_button);
		imagebutton_enter_button1 = new ImageButton(this.leftPos + 145, this.topPos + 42, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(4, x, y, z));
						FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 4, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button1", imagebutton_enter_button1);
		this.addRenderableWidget(imagebutton_enter_button1);
		imagebutton_enter_button2 = new ImageButton(this.leftPos + 145, this.topPos + 78, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(5, x, y, z));
						FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 5, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button2", imagebutton_enter_button2);
		this.addRenderableWidget(imagebutton_enter_button2);
		imagebutton_edit_button = new ImageButton(this.leftPos + 122, this.topPos + 6, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/edit_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/edit_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(6, x, y, z));
						FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 6, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button", imagebutton_edit_button);
		this.addRenderableWidget(imagebutton_edit_button);
		imagebutton_edit_button1 = new ImageButton(this.leftPos + 122, this.topPos + 42, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/edit_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/edit_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(7, x, y, z));
						FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 7, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button1", imagebutton_edit_button1);
		this.addRenderableWidget(imagebutton_edit_button1);
		imagebutton_edit_button2 = new ImageButton(this.leftPos + 122, this.topPos + 78, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/edit_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/edit_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new FillerItemCodeBlockGUI2ButtonMessage(8, x, y, z));
						FillerItemCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 8, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button2", imagebutton_edit_button2);
		this.addRenderableWidget(imagebutton_edit_button2);
	}
}
